test-functions revision 53d90f9582f96208b3674da823ad1a3d2c3b1aa4
e50e53876fb08b6d7ba2290b1ebb77286f5a9481Evgeny Vereshchagin# -*- mode: shell-script; indent-tabs-mode: nil; sh-basic-offset: 4; -*-
e50e53876fb08b6d7ba2290b1ebb77286f5a9481Evgeny Vereshchagin# ex: ts=8 sw=4 sts=4 et filetype=sh
e50e53876fb08b6d7ba2290b1ebb77286f5a9481Evgeny Vereshchaginif ! ROOTLIBDIR=$(pkg-config --variable=systemdutildir systemd); then
e50e53876fb08b6d7ba2290b1ebb77286f5a9481Evgeny Vereshchagin echo "WARNING! Cannot determine rootlibdir from pkg-config, assuming /usr/lib/systemd" >&2
e50e53876fb08b6d7ba2290b1ebb77286f5a9481Evgeny VereshchaginBASICTOOLS="sh bash setsid loadkeys setfont login sulogin gzip sleep echo mount umount cryptsetup date dmsetup modprobe"
e50e53876fb08b6d7ba2290b1ebb77286f5a9481Evgeny VereshchaginDEBUGTOOLS="df free ls stty cat ps ln ip route dmesg dhclient mkdir cp ping dhclient strace less grep id tty touch du sort"
e50e53876fb08b6d7ba2290b1ebb77286f5a9481Evgeny Vereshchagin # SUSE and Red Hat call the binary qemu-kvm
e50e53876fb08b6d7ba2290b1ebb77286f5a9481Evgeny Vereshchagin [ "$QEMU_BIN" ] || QEMU_BIN=$(which -a kvm qemu-kvm 2>/dev/null | grep '^/' -m1)
e50e53876fb08b6d7ba2290b1ebb77286f5a9481Evgeny Vereshchagin # QEMU's own build system calls it qemu-system-x86_64
e50e53876fb08b6d7ba2290b1ebb77286f5a9481Evgeny Vereshchagin [ "$QEMU_BIN" ] || QEMU_BIN=$(which -a qemu-system-x86_64 2>/dev/null | grep '^/' -m1)
e50e53876fb08b6d7ba2290b1ebb77286f5a9481Evgeny Vereshchagin [ "$QEMU_BIN" ] || QEMU_BIN=$(which -a qemu-system-i386 2>/dev/null | grep '^/' -m1)
e50e53876fb08b6d7ba2290b1ebb77286f5a9481Evgeny Vereshchagin [ "$QEMU_BIN" ] || QEMU_BIN=$(which -a qemu 2>/dev/null | grep '^/' -m1)
e50e53876fb08b6d7ba2290b1ebb77286f5a9481Evgeny Vereshchagin echo "Could not find a suitable QEMU binary" >&2
e50e53876fb08b6d7ba2290b1ebb77286f5a9481Evgeny Vereshchagin [ "$KERNEL_BIN" ] || KERNEL_BIN=/boot/vmlinuz-$KERNEL_VER
e50e53876fb08b6d7ba2290b1ebb77286f5a9481Evgeny Vereshchagin [ "$INITRD" ] || INITRD=/boot/initramfs-${KERNEL_VER}.img
e50e53876fb08b6d7ba2290b1ebb77286f5a9481Evgeny Vereshchaginraid=noautodetect \
e50e53876fb08b6d7ba2290b1ebb77286f5a9481Evgeny Vereshchaginconsole=ttyS0 \
-smp $QEMU_SMP \
-kernel $KERNEL_BIN \
../../systemd-nspawn --boot --directory=$TESTDIR/nspawn-root $ROOTLIBDIR/systemd $KERNEL_APPEND
type -P dmeventd >/dev/null && dracut_install dmeventd
inst_libs $i
ret=1
[[ -e $TESTDIR/nspawn-root/testok ]] && ret=0
[[ -f $TESTDIR/nspawn-root/failed ]] && cp -a $TESTDIR/nspawn-root/failed $TESTDIR
return $ret
find "$initdir" -executable -not -path '*/lib/modules/*.ko' -type f | xargs strip --strip-unneeded | ddebug
inst $i
if [[ -d $initdir/lib/modules/$KERNEL_VER ]] && \
rm -f $initdir/{usr/lib,etc}/systemd/system/plymouth* $initdir/{usr/lib,etc}/systemd/system/*/plymouth*
cp -a /etc/ld.so.conf* $initdir/etc
[[ $BASICTOOLS ]] && dracut_install $BASICTOOLS
[[ $DEBUGTOOLS ]] && dracut_install $DEBUGTOOLS
find \
| while read file; do
find \
| while read file; do
for i in \
inst $i
for i in \
/usr/lib/kbd/consolefonts/eurlatgr* \
/usr/lib/kbd/consolefonts/latarcyrheb-sun16*; do
inst $i
[ -f ${_terminfodir}/l/linux ] && break
dracut_install -o ${_terminfodir}/l/linux
sed "s#@SYSTEMCTL@#$(type -P systemctl)#g" $TEST_BASE_DIR/end.service.in > $initdir/etc/systemd/system/end.service
ln -fs $TEST_BASE_DIR/testsuite.service $initdir/etc/systemd/system/testsuite.target.wants/testsuite.service
for d in usr/bin usr/sbin bin etc lib "$libdir" sbin tmp usr var var/log dev proc sys sysroot root run run/lock run/initramfs; do
local _bin=$1
if [[ $_line =~ $_so_regex ]]; then
_file=${BASH_REMATCH[1]}
[[ -e $STATEFILE ]] && . $STATEFILE
export TESTDIR
export initdir
[ $1 -le $LOG_LEVEL ] || return 0
if [ $# -ge 1 ]; then
while read line; do
while [[ ${__absolute[__level]} == ${__current[__level]} ]]
if [[ -n $__newpath ]]
if [[ -L $_file ]]; then
# rev_lib_symlinks libfoo.so.8.1
if [[ -L $_src ]]; then
[[ -L $_bin ]] && inst_symlink $_bin $_target && return 0
if [[ $_line =~ $_so_regex ]]; then
_file=${BASH_REMATCH[1]}
local _bin
local _line _shebang_regex
[[ $_line =~ $_shebang_regex ]] || return 1
if [[ -d $_realsrc ]]; then
if [[ -f $r/$_rule ]]; then
if [[ -f ${r}$_rule ]]; then
local _x
case $# in
[[ $initdir = $2 ]] && set $1;;
for _x in inst_symlink inst_script inst_binary inst_simple; do
local to f
if [[ $_optional = yes ]]; then
if [[ $omit_drivers ]]; then
_found=1
local _modname _filtercmd
if ! [[ $hostonly ]]; then
if ! [[ $hostonly ]]; then
[[ $no_kernel = yes ]] && return
local _fderr=9
| instmods
| instmods
local _moddirname=${KERNEL_MODS%%/lib/modules/*}
--set-version $KERNEL_VER ${_moddirname} $_mpargs
return $_ret
while read _mod; do
set -o pipefail
| while read line; do [[ "$line" =~ $_filter_not_found ]] && echo $line || echo $line >&2 ;done | derror
_ret=$?
set +o pipefail
return $_ret
local _pattern=$1
case $1 in
--run)
ret=$?
exit $ret;;
--setup)
--clean)
--all)
ret=$?
exit $ret
ret=$?
exit $ret;;